#include <iostream>
#include <sstream>
#include <fstream>
#include <cassert>
#include "LinearNeuron.hxx"

using namespace std;

static const double x1[] = {0,  1,  -1,  2,  -1,  2,  -2,  2,  -2};
static const double x2[] = {0,0.9,-0.9,1.9,-1.1,2.1,-2.1,2.1,-1.9};
static const double  d[] = {1, -1,   1, -1,  -1,  1,  -1,  1,   1};

/*
static const double x1[] = { -1, 0, 1, -1};
static const double x2[] = {  1, 0, 1,  1};
static const double  d[] = { -1, 0, 1, -1};
*/

int main ( int argc, char **argv ) {
    int errors;
    stringstream filename;
    ofstream fout;
    srand(time(NULL)*getpid());
    ai::LinearNeuron *ln1 = new ai::LinearNeuron();

    assert(argc > 1);
    ln1->setA(atof(argv[1]));

    filename << "a-" << atof(argv[1]) << ".dat";
    fout.open(filename.str().c_str());

    for ( int i = 0 ; ; ++i ) {
	cout << "== Epoch " << i << " ==" << endl;
	errors = 0;

	for ( int j = 0 ; j < 9; ++j ) {
	    cout << "x1: " << x1[j] << ", x2: " << x2[j];

	    int y = ln1->decide(x1[j], x2[j]);
	    
	    cout << " --> y: " << y << ", d: " << d[j] << " - "
		 << ((y == d[j]) ? "Good" : "BAD!") << endl;

	    if (y != d[j]) {
		ln1->modifyWeight((d[j] - y) * -1, (d[j] - y) * x1[j], (d[j] - y) * x2[j]);
		//ln1->setA(1.0/(i+1));
		++errors;
	    }
	}
	
	fout << i << " " << errors << endl;

	if (errors <= 0)
	    break;
    }

    delete ln1;
    fout.close();
    return 0;
}
