#include <iostream>

namespace ai {

    class LinearNeuron {
	public:

	    LinearNeuron () {
		w0 = 10.0 * rand() / (RAND_MAX + 1.0);
		w1 = 10.0 * rand() / (RAND_MAX + 1.0);
		w2 = 10.0 * rand() / (RAND_MAX + 1.0);
		a = 0;
	    }

	    int decide ( const double &x1, const double &x2 ) {
		double s = - w0 + (w1 * x1) + (w2 * x2);
		std::clog << " * s: " << s << std::endl;
		return (s < 0) ? -1 : 1;
	    };

	    void modifyWeight ( const double &mw0, const double &mw1, const double &mw2 ) {
		w0 += a * mw0;
		w1 += a * mw1;
		w2 += a * mw2;
		std::clog << " * w0: " << w0 << ", w1: " << w1 << ", w2: " << w2 << std::endl;
	    };

	    void setA ( const double &_a ) {
		a = _a;
		std::clog << " * a: " << a << std::endl;
	    }

	private:
	    double w0, w1, w2;
	    double a;
    };

};
